/* -*-C-*- cuseri.c */
/*-->cuserid*/
/**********************************************************************/
/****************************** cuserid ******************************/
/**********************************************************************/

#include "headers.h"

RCSID("$Id: cuseri.c,v 1.1 2004/01/23 17:53:46 beebe Exp beebe $")

#if defined(HAVE_CUSERID)
static int have_cuserid = 0;		/* ensure non-empty object file */
					/* because some linkers reject them */
#else  /* supply private version of cuserid() */

#if    PCC_20

#ifdef tops20
#undef tops20
#endif /* tops20 */
				/* to avoid macro substitution */
#include <tops20.h>			/* gets jsys.h and byteptr.h; */
#define tops20 1
#endif /* PCC_20 */

#if    KCC_20
#include <local-jsys.h>
#ifndef ac1
static int acs[5];
#define ac1 acs[1]
#define ac2 acs[2]
#define ac3 acs[3]
#define ac4 acs[4]
#endif /* ac1 */
#endif /* KCC_20 */

/* BSD 4.x, Sys V, and IBM AIX all have cuserid(), but NeXT with MACH is
lacking it.  The version implemented here should work for all these systems. */

#define MAXUSERNAME	39

char*
#if STDC
cuserid(
char  *s
)
#else /* NOT STDC */
cuserid(s)
char  *s;
#endif /* STDC */
{
    static char		username[MAXUSERNAME+1];

    username[0] = '\0';			/* default value is empty string */

#if    KCC_20
    (void)jsys(GJINF,acs);
    ac2 = ac1;				/* user number */
    ac1 = (int)(username-1);		/* Monitor wants ILDB */
					/* pointer, not LDB pointer*/
    (void)jsys(DIRST,acs);
#endif /* KCC_20 */

#if    PCC_20
    (void)jsys(JSgjinf,acs);
    ac2 = ac1;				/* user number */
    ac1 = POINT(username);
    (void)jsys(JSdirst,acs);
#endif /* PCC_20 */

#if    OS_UNIX
    {
	char			*p;
	struct passwd		*pw;

	p = getlogin();
	if (p == (char*)NULL)
	{
	    pw = getpwuid(getuid());
	    if (pw != (struct passwd *)NULL)
		p = pw->pw_name;
	}
	if (p != (char*)NULL)
	    (void)strncpy(username,p,MAXUSERNAME);
    }
#endif /* OS_UNIX */

    if (s != (char*)NULL)
	(void)strcpy(s,username);

    return ((char*)username);
}
#endif
